Imports Microsoft.VisualBasic
Imports System.ComponentModel

''' <summary> 
'''  Treeview mit integrierter Imagelist fr Drive, Folder, File 
''' </summary>
Public Class FileSystemTreeView : Inherits TreeView
    ' Erweiterungsfhig in Richtung TreeViews, die auch Dateien anzeigen
    '  (was FolderTreeView ja nicht tut)

#Region "GeneratedCode"

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = _
            New System.ComponentModel.ComponentResourceManager( _
                GetType(FileSystemTreeView) _
            )
        Me.IconList = New System.Windows.Forms.ImageList(Me.components)
        Me.SuspendLayout()
        '
        'IconList
        '
        Me.IconList.ImageStream = CType( _
            resources.GetObject("IconList.ImageStream"),  _
            System.Windows.Forms.ImageListStreamer)
        Me.IconList.TransparentColor = System.Drawing.Color.Transparent
        Me.IconList.Images.SetKeyName(0, "OpenFolder")
        Me.IconList.Images.SetKeyName(1, "ClosedFolder")
        Me.IconList.Images.SetKeyName(2, "File")
        Me.IconList.Images.SetKeyName(3, "Drive")
        '
        'FileSystemTreeView
        '
        Me.HideSelection = False
        Me.ResumeLayout(False)

    End Sub

    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing AndAlso components IsNot Nothing Then
            components.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub
    Protected WithEvents IconList As System.Windows.Forms.ImageList

    Private components As IContainer
#End Region 'GeneratedCode

#Region "ShadowAwayIconStuff"
    ' Da bei diesem Treeview die Icons mit drin sind, muss die geerbte
    '  Icon-Funktionalitt deaktiviert werden

    <Browsable(False)> _
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Shadows ReadOnly Property ImageKey() As String
        Get
            Return MyBase.ImageKey
        End Get
    End Property


    <Browsable(False)> _
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Shadows ReadOnly Property ImageList() As ImageList
        Get
            Return MyBase.ImageList
        End Get
    End Property

    <Browsable(False)> _
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Shadows ReadOnly Property SelectedImageKey() As String
        Get
            Return MyBase.SelectedImageKey
        End Get
    End Property

    <Browsable(False)> _
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Shadows ReadOnly Property ImageIndex() As Integer
        Get
            Return MyBase.ImageIndex
        End Get
    End Property

    <Browsable(False)> _
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)> _
    Public Shadows ReadOnly Property SelectedImageIndex() As Integer
        Get
            Return MyBase.SelectedImageIndex
        End Get
    End Property

#End Region 'ShadowAwayIconStuff

    Public Enum NodeType
        OpenFolder
        ClosedFolder
        File
        Drive
    End Enum

    Protected Shared ReadOnly _Separator As Char = _
        IO.Path.DirectorySeparatorChar

    Public Sub New()
        InitializeComponent()
        MyBase.PathSeparator = _Separator
        MyBase.ImageIndex = NodeType.ClosedFolder
        MyBase.SelectedImageIndex = NodeType.OpenFolder
        MyBase.ImageList = IconList
    End Sub

End Class
